param starttime2;
let starttime2:= time();

model Pruitt_PRUITT.mod;
data LA_Hotel_PRUITT_1.dat;

option presolve 0;
option solver cplexamp123;
option cplex_options 'timing 1 feasibility 0.01 mipgap 0.01 mipdisplay 3 mipemphasis 2 timelimit 36000';
option display_1col 9000;


problem UnderEstimate: 
GA,HA,VA,SA,WA,WB,GN,HN,GY,HY,P,CP,V,WC,WD,SC,CR,DR,EP,ES,E,GE,HE,GNG,HNG,BNG,WY,WX,W,UE,
under_cost, 
demande,demandh,minmax,netgen,maxpowv,pow_lo,pow_hi,pow_buyon,
chp_lo,chp_hi,chp_buyon,pow_rup,pow_rdown,chp_rup,chp_rdown,
pow_oninc,chp_oninc,ggas,hgas,bgas,pow_eff,chp_eff,
tankacq1,tankacq2,tanktemp,temp1,tankheat1,temp3,temp4,temp5,temp6,temp7,
soc,soc_init,st_upcap,st_locap,charge,deplete,
under1,under2,under3,under4,under5,under6,under7,under8,under9,under10,
under11,under12,under13,under14,under15,under16,under17,under18,under19,under20,
under21,under22,under23,under24,under25,under26,under27,under28,under29,under30,
under31,under32,under33,under34,under35,under36,under37,under38,under39,under40,
under41,under42,under43,under44,under45,under46,under47,under48,under49,under50,
under51,under52;

problem Heuristic:
dGA,dHA,dSA,dVA,dGN,dHN,dGY,dHY,dP,dCP,dV,dSC,dCR,dDR,dEP,dES,dE,dGNG,dHNG,dWA,dWB,dWD,dWC,dBNG,
heuristic_cost,
ddemande,dminmax,dnetgen,dmaxpowv,dpow_lo,dpow_hi,dpow_buyon,dchp_lo,dchp_hi,dchp_buyon,
dpow_rup,dpow_rdown,dchp_rup,dchp_rdown,dpow_oninc,dchp_oninc,dggas,dhgas,dpow_eff,dchp_eff,
ddemandh,dbgas,dtanktemp,dtemp1,dtankheat1,dtankacq1,dtankacq2,dtanksize1,dtanksize2,
dsoc,dsoc_init,dst_upcap,dst_locap,dcharge,ddeplete; 


####When running the full year instance, replace the first term in grid_cost (cd*(max{t in T}de[t])) with
####(sum{n in N}(cd[n]*(max{t in Tn[n]}de[t]))).

param grid_cost;
let grid_cost:= cd*(max{t in T}de[t]) + tau*sum{t in T}((ce[t]+zt*zu)*de[t]) + tau*sum{t in T}((bom*fb+cg[t]+zt*zg)*(dh[t]/fb));



##############Underestimation Problem###############

let {t in T}GNhi[t]:= iGNhi[t];
let {t in T}GNlo[t]:= iGNlo[t];
let {t in T}GGhi[t]:= iGGhi[t];
let {t in T}GGlo[t]:= iGGlo[t];
let {t in T}GEhi[t]:= iGEhi[t];
let {t in T}GElo[t]:= iGElo[t];
let {t in T}HNhi[t]:= iHNhi[t];
let {t in T}HNlo[t]:= iHNlo[t];
let {t in T}HGhi[t]:= iHGhi[t];
let {t in T}HGlo[t]:= iHGlo[t];
let {t in T}HEhi[t]:= iHEhi[t];
let {t in T}HElo[t]:= iHElo[t];
let {t in T}WChi[t]:= iWChi[t];
let {t in T}WClo[t]:= iWClo[t];
let {t in T}WDhi[t]:= iWDhi[t];
let {t in T}WDlo[t]:= jWDlo[t];
let {t in T}Whi[t]:= jWhi[t];
let {t in T}Wlo[t]:= iWlo[t];
let {t in T}WXhi[t]:= iWXhi[t];
let {t in T}WXlo[t]:= iWXlo[t];
let {t in T}WYhi[t]:= jWYhi[t];
let {t in T}WYlo[t]:= iWYlo[t];
let WAhi:= iWAhi;
let WAlo:= iWAlo;

solve UnderEstimate;

param lowerbound_totalcost;
let lowerbound_totalcost:= under_cost;

param GA_low;
let GA_low:= GA;
param HA_low;
let HA_low:= HA;
param VA_low;
let VA_low:= VA;
param SA_low;
let SA_low:= SA;
param WA_low;
let WA_low:= WA;



##############Linearization Heuristic##################


##Without heat capture

let {t in T}dGE[t]:= (if GN[t]>0 then 0.61-0.02*(P[t]/GN[t]) else 0.41);
let {t in T}dHE[t]:= (if HN[t]>0 then 0.61-0.02*(CP[t]/HN[t]) else 0.41);
let {t in T}dW[t]:= wr;
let {t in T}dWX[t]:= 0;
let {t in T}dWY[t]:= 0;

solve Heuristic;

param upperbound_totalcost_pow;
let upperbound_totalcost_pow:= heuristic_cost;

param dGA_pow;
let dGA_pow:= dGA;
param dHA_pow;
let dHA_pow:= dHA;
param dVA_pow;
let dVA_pow:= dVA;
param dSA_pow;
let dSA_pow:= dSA;
param dWA_pow;
let dWA_pow:= dWA;


##With heat capture

let dW[1]:=wh;
let dWX[1]:=1;
let dWY[1]:=0;
param flow{t in T};
let flow[1]:= dh[1]/(ws*(wh-wr));

for {t in T: t>1}{

	let dW[t]:= max(wr, min(wu, (1-wd*dWX[t-1])*dW[t-1]+(1/(ws*WA))*(tau*we*fs*fh*(CP[t-1]/dHE[t-1])*(ft-dW[t-1])-tau*ws*flow[t-1]*(dW[t-1]-wr))));
	let dWX[t]:= (if dW[t]>wr+0.1 then 1 else 0);
	let dWY[t]:= (if dW[t]>wh then 1 else 0);
	let flow[t]:= (1-(1-((wh-wl)/(dW[t]-wl)))*dWY[t])*(dh[t]/(ws*(wh-wr)));
	}

let dW[1]:=dW[card(T)];
let dWX[1]:=(if dW[1]>wr+0.1 then 1 else 0);
let dWY[1]:=(if dW[1]>wh then 1 else 0);
let flow[1]:= (1-(1-((wh-wl)/(dW[1]-wl)))*dWY[1])*(dh[1]/(ws*(wh-wr)));

for {t in T: t>1}{

	let dW[t]:= max(wr, min(wu, (1-wd*dWX[t-1])*dW[t-1]+(1/(ws*WA))*(tau*we*fs*fh*(CP[t-1]/dHE[t-1])*(ft-dW[t-1])-tau*ws*flow[t-1]*(dW[t-1]-wr))));
	let dWX[t]:= (if dW[t]>wr+0.1 then 1 else 0);
	let dWY[t]:= (if dW[t]>wh then 1 else 0);
	let flow[t]:= (1-(1-((wh-wl)/(dW[t]-wl)))*dWY[t])*(dh[t]/(ws*(wh-wr)));
	}

solve Heuristic;

param upperbound_totalcost_chp;
let upperbound_totalcost_chp:= heuristic_cost;

param dGA_chp;
let dGA_chp:= dGA;
param dHA_chp;
let dHA_chp:= dHA;
param dVA_chp;
let dVA_chp:= dVA;
param dSA_chp;
let dSA_chp:= dSA;
param dWA_chp;
let dWA_chp:= dWA;



param runtime2;
let runtime2:= time() - starttime2;

display runtime2,grid_cost,lowerbound_totalcost,GA_low,HA_low,VA_low,SA_low,WA_low,upperbound_totalcost_pow,dGA_pow,dHA_pow,dVA_pow,dSA_pow,dWA_pow,upperbound_totalcost_chp,dGA_chp,dHA_chp,dVA_chp,dSA_chp,dWA_chp,dGN,dGY,dP,dGNG,dGE,dHN,dHY,dCP,dHNG,dHE,dW,dWX,dWY,dWC,dWD,dV,dSC,dCR,dDR,dEP,dES>pruitt.out;



